; (c) 2008-2013 by mr schnada <webmaster at schnada de>

;;; load sxml sources into schnada db and generate html pages

(define pages-dir "../pages")

;;  ... harumph ...
(define (page-code->default-fragment sxml)
  (if (string= "www.culious.freehosting.net"
               (page-server/1 sxml))
      "impressum"
      #f))

(define schnada-web (make-web-database pages-dir))


(define (schnada-sourcename label)
  (string-append pages-dir "/" label ".scm"))

(define (load-schnada-db)
  (enter-dir-into-db pages-dir schnada-web page-code->default-fragment))

(define (regenerate-schnada label)
  (with-cwd pages-dir
    (with-output-to-file (ensure-parent-dirs
                          (page-filename schnada-web label))
      (lambda () (sxml->html (page-xcode/2 schnada-web label))))))

(define (generate-schnada label)
  (format #t "Generate ~s~%" label)
  (enter-page-into-db (schnada-sourcename label) schnada-web
                      page-code->default-fragment)
  (regenerate-schnada  label))

(define (fully-generate-schnada label)
  (load-schnada-db)
  (regenerate-schnada label))

(define (generate-schnadamap nickname->prio nickname->freq server)
  ;; (format #t "Generate sitemap for ~a~%" server)
  (with-cwd pages-dir
    (let ((ofile (path-list->file-name (list server "sitemap.xml"))))
      (with-output-to-file ofile
        (lambda ()
          (format #t "<?xml version=\"1.0\" encoding=\"UTF-8\"?>~%")
          (sxml->xml (pages->sitemap-sxml
                      schnada-web
                      (web-database-nicknames schnada-web server)
                      nickname->prio nickname->freq))))
      (run (gzip -c -9 ,ofile) (> ,(string-append ofile ".gz"))))))

