; (c) 2008 by mr schnada <webmaster at schnada de>

;;; s48 module wrapper around r.a.o'keefe's "sort.scm"
;;; http://www.math.purdue.edu/~lucier/615/software/sort.scm
;;; which contains ample documentation and comments;
;;; cf. also srfi-95.

(define-interface sort-interface
  (export sorted?
          merge merge!
          sort sort!
          keyed))

(define-structure sort-lib sort-interface
  (open scheme)
  (begin (define-syntax declare
           (syntax-rules ()
             ((_ ?x ...)
              (begin))))
         (define (keyed less? key) (lambda (x y) (less? (key x) (key y)))))
  (files "sort.scm"))


;;; a simple html generator for mr.schnada's websites

(define-interface schnada-interface
  (export load-schnada-db
          generate-schnada
          fully-generate-schnada
          generate-schnadamap))

(define-interface statixite-interface
  (export make-web-database
          page-filename
          page-xcode/2
          page-server/1
          sxml->html
          enter-dir-into-db
          enter-page-into-db
          ensure-parent-dirs
          sxml->xml
          web-database-nicknames
          pages->sitemap-sxml
          ))

(define-structure statixite statixite-interface
  (open oleg-utils sxml-tree-trans sxml-to-html
        tables krims let-opt uri image-info
        srfi-1 srfi-2 srfi-9 srfi-13
        (subset scsh-reader (scsh-read))
        sort-lib
        scsh
        (modify scheme
                (hide map for-each member assoc)             ; cf srfi-1
                (hide string->list string-copy string-fill!) ; cf srfi-13
                ))
  (begin (define read-cs scsh-read))    ; case-sensitive reader
  (files "trafo-sxml.scm"
         "webpage-db.scm"
         "sxml2html.scm"
         "sxml2xml.scm"
         "sxml-utils.scm"
         "sitemap.scm"
         "aux.scm"))

(define-structure schnada schnada-interface
  (open statixite srfi-13 scsh
        (modify scheme
                (hide string->list string-copy string-fill!) ; cf srfi-13
                ))
  (files "generate.scm"))
