; (c) 2013 by mr schnada <webmaster at schnada de>

(define (file-last-mod fname)
  (string->number (run/string (stat --printf=%Y ,fname))))

(define (file-name->iso-mtime fname)
  (let ((seconds (file-last-mod fname)))
    (format-date "~Y-~m-~dT~H:~M:~S+00:00" (date seconds  0))))

(define (freq<? x y)
  (let* ((freqs '("yearly" "monthly" "weekly" "daily"))
         (ix (list-index (lambda (f) (equal? x f)) freqs))
         (iy (list-index (lambda (f) (equal? y f)) freqs)))
    (< ix iy)))

;; convert hopefully float x in the canonical xml form
(define (float->string x)
  (let ((s (number->string x)))
    (if (string-suffix? "." s)
        (string-append s "0")
        s)))

;; assume cwd = pages-dir
(define (pages->sitemap-sxml db labels label->prio label->freq)
  `(urlset (@ (xmlns:xsi "http://www.w3.org/2001/XMLSchema-instance")
              (xsi:schemaLocation "http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd")
              (xmlns "http://www.sitemaps.org/schemas/sitemap/0.9"))
           ,@(map (lambda (label)
                    `(url (loc ,(page-uri db label))
                          (lastmod ,(file-name->iso-mtime
                                     (page-filename db label)))
                          (changefreq ,(label->freq label))
                          (priority ,(float->string (label->prio label)))))
                  (sort! labels (lambda (y x)
                                  (let ((prio-x (label->prio x))
                                        (prio-y (label->prio y))
                                        (freq-x (label->freq x))
                                        (freq-y (label->freq y)))
                                    (or (< prio-x prio-y)
                                        (and (= prio-x prio-y )
                                             (freq<? freq-x freq-y)))))))))
