;;;; these test cases badly want maintenance

(define (false . xs) #f)

#!
(let ((equal? (lambda (x y)
                (format #t "~s = ~s~%" x y)
                (equal? x y)))
      (id (lambda (u) (unparse-uri (receive xs (parse-uri u) xs))))
      (u0 "p://s/x/y?s#f")
      (u1 "p:///#f")
      (u2 "x#f"))
  (display (list (equal? u0 (id u0))
                 (equal? u1 (id u1))
                 (equal? u2 (id u2))))
  (newline))
!#

#!
(let ((equal? (lambda (x y)
                (format #t "~s = ~s~%" x y)
                (equal? x y))))
  (display (map (lambda (args+result)
                  (equal? (apply relativise-path (first args+result))
                          (second args+result)))
                '(((("x" "y" "z") ("x" "y" "zed"))
                   ("zed"))
                  ((("x" "y" "z") ("x" "u" "v"))
                   (".." "u" "v"))
                  ((("x" "y" "z") ("u" "v" "w"))
                   (".." ".." "u" "v" "w"))
                  ((("x") ("x"))
                   ("x"))
                  ((("") ("x"))
                   ("x"))
                  ((("x") (""))
                   (""))
                  ((("x" "y") ("X" "y"))
                   (".." "X" "y"))
                  ((("" "" "s" "x") ("" "" "s" "y"))
                   ("y"))
                  ((("" "" "s" "x") ("" "" "v" "y"))
                   ("" "" "v" "y"))
                  ((("" "" "s" "x") ("" "" "S" "y"))
                   ("y"))
                  ))))

(let ((equal? (lambda (x y)
                (format #t "~s = ~s~%" x y)
                (string= x y))))
  (display (list
                 (equal? (relativise-uri "p://s/a/b/c?s#f" "s://s/a/b/c?s#f")
                         "s://s/a/b/c?s#f")
                 (equal? (relativise-uri "p://s/a/b/c?s#f" "p://s/a/b/d?q#i")
                         "d?q#i")
                 (equal? (relativise-uri "/a/b/c/" "/a/b/c/")
                         "")
                 (equal? (relativise-uri "/" "/b")
                         "b")
                 )))
!#


#!
(let ((equal? (lambda (x y)
                (format #t "~s = ~s~%" x y)
                (equal? x y))))
  (display (list
                 (equal? (uri-path-root '("" "" "y" ""))
                         '("" "" "y" ""))
                 (equal? (uri-path-root '("" "" "y"))
                         '("" "" "y" ""))
                 (equal? (uri-path-root '("" "x"))
                         '(""))
                 (equal? (uri-path-root '("x"))
                         '(""))
                 (equal? (uri-path-root '())
                         '(""))
                 )))
!#

#!
(let ((equal? (lambda (x y)
                (format #t "~s = ~s~%" x y)
                (string= x y))))
  (display (list
                 (equal? (uri-root "x://y/z?q#i")
                         "x://y/")
                 (equal? (uri-root "x://y")
                         "x://y/")
                 (equal? (uri-root "/x/y/z#i")
                         "/")
                 (equal? (uri-root "x/y/z#i")
                         "/")
                 (equal? (uri-root "")
                         "/")
                 )))
!#

; test
#!
(format #t "~a~%"
        (let ((pred (lambda (x)
                      (and (pair? x)
                           (eqv? 'foo (car x))
                           x))))
          (list (equal? (any-sexp pred '()) #f)
                (equal? (any-sexp pred '(foo)) '(foo))
                (equal? (any-sexp pred '(fu (bar) (foo) (bax))) '(foo))
                (equal? (any-sexp pred '(fu (bar (baz (foo))))) '(foo))
                (equal? (any-sexp pred '(fu (bar (baz (foo ""))) (foo)))
                        '(foo)))))
!#


#!
(let ((equal? (lambda (x y)
                (format #t "~s = ~s~%" x y)
                (string= x y))))
  (and (equal? (donate-label #f "baalpfig")
               "5kronen-priesterin")
       (equal? (donate-label #f "5kronen-priesterin")
               "baalpfig")
       (string? (donate-label #f "foo"))
       ))
!#

#!
(define (table-keys table)
  (let ((keys (list)))
    (table-walk (lambda (k v)
                  (set! keys (cons k keys)))
                table)
    keys))
;; obs
(define (schnada-quotes)
  (table-keys (web-database-quo-table schnada-web)))

(write (trafo-sxml/macros '(final "<>") #f #f))
(write (trafo-sxml/macros '(ali "" (final "<>")) #f #f))
(write (trafo-sxml/macros '(ali "" "<>") #f #f))
(write (trafo-sxml/macros '(heading (@ (id "foo") (w8 "3")) "foobar") #f #f))
(write (trafo-sxml/macros '(heading (@ (lang "de") (name "foo") (w8 "3")) "foobar") #f #f))
(write (trafo-sxml/macros '(crypt "foobar") #f #f))
(write (trafo-sxml/macros '(reli "url" "text") #f #f))
(write (trafo-sxml/macros '(chili "*200706" "contact") schnada-web "contact"))
(write (trafo-sxml/macros '(apage "contact") schnada-web "contact"))
(write (trafo-sxml/macros '(apage "contact" "" "takt") schnada-web "contact"))
(write (trafo-sxml/macros '(ares "gabriel") schnada-web "foo"))

(write (trafo-sxml/macros '(quol (@ (lang "fr")) (p (cite "A. Utor")) (li (p "..."))) schnada-web "contact"))
(write (trafo-sxml/macros '(quol (@ (lang "fr")) (p (cite "A. Utor")) (li (p "...")) (li (p "..."))) schnada-web "contact"))
(write (trafo-sxml/macros '(quotesl (li "any") (li "bark")) schnada-web "contact"))
!#

#!
(sxml->html '(li (a (@ (href (*text* "<>")))
                           (final (*text* "<>")))))
(sxml->html '(p (include "test/alpha.txt")))
(sxml->html (trafo-sxml/macros '(p ">>>" uuml "<<<") #f #f))
(sxml->html (trafo-sxml/macros '("" uuml) #f #f))
(sxml->html (trafo-sxml/macros '(include "test/tespg-1.scm" "txt")
                               #f #f))
(sxml->html (trafo-sxml/macros '(includex "test/tespg-1.scm")
                               #f #f))
!#

#!
(define test-db (make-web-database "test"))
(enter-page-into-db "test/tespg-1.scm" test-db)
(enter-page-into-db "test/tespg-2.scm" test-db)
(enter-page-into-db "test/contact.scm" test-db)
(define tespg-1 (page-record test-db "tespg-1"))
(define xtespg-1 (page-xcode/2 test-db "tespg-1"))
(define xtespg-2 (page-xcode/2 test-db "tespg-2"))
(sxml->html xtespg-1)
(sxml->html xtespg-2)
!#

#!
(sxml->xml '(foo))
(sxml->xml '(foo (@ (bar "max") (baz "moritz"))))
(sxml->xml '(foo (bar)))
!#

#!
(define test-db (make-web-database "./test"))
(define esxe '(p "L'"Eacute"cole"))
(define esxe '(page (rtape
                     (loco "http://www.foo.org/contact.html")
                     (up "foo"))
                    (title "contact")
                    (p "L'"Eacute"cole")) )
(define bsxe (trafo-sxml/macros sxe test-db "contact"))
(write bsxe)
(sxml->html bsxe)

(enter-page-into-db "test/contact.scm" test-db false)
(define esxe (page-code (page-record test-db "contact")))
(define bsxe (page-xcode/2 test-db "contact"))
(sxml->html bsxe)

(define esxe
  (with-input-from-file "test/contact.scm" read))

(write (with-input-from-file "test/x.scm" read))
(write (with-input-from-file "test/x.scm" read-cs))
!#
