; (c) 2008 by mr schnada <webmaster at schnada de>

;;;; sxml trafos for schnada.de
;;;;   navigation elements and the like specific to schnada.de

;;; "queries" of the "database" of schnada.de webpages

(define (vamarkup-href db label)
  "http://validator.w3.org/check?uri=referer")

(define (vamarkup*-href db label)
  "http://www.htmlhelp.org/cgi-bin/validate.cgi?url=http%3A%2F%2Fwww.schnada.de%2F&warnings=yes&spider=yes")

(define (valinks-href db label)
  (append (cons "http://validator.w3.org/checklink?uri="
                (encode-url (page-uri db label)))
          '("&hide_type=all&depth=&check=Check")))

(define (valinks*-href db label)
  "http://www.htmlhelp.org/tools/valet/linktest.cgi?url=http%3A%2F%2Fwww.schnada.de%2F&date=2006-01-01&type=Full")

(define (vastyle-href db label)
  (list "http://jigsaw.w3.org/css-validator/validator?uri=http%3A%2F%2F"
        (page-server db label)
        "%2Fsty%2Fstengel.css&warning=2&profile=css2"))


(define (trafo-checker db label)
  `(p (@ (class "navbar") (lang "en"))
      "{ Check "
      (a (@ (rel "nofollow")
            (href ,(vamarkup-href db label))) "markup")
        " (" (a (@ (rel "nofollow")
                   (href ,(vamarkup*-href db label))) "*") ") | "
      (a (@ (rel "nofollow")
            (href ,(valinks-href db label))) "links")
        " (" (a (@ (rel "nofollow")
                   (href ,(valinks*-href db label))) "*") ") | "
      (a (@ (rel "nofollow")
            (href ,(vastyle-href db label))) "style")
      " }" ))


(define (stengel-uri db label)
  (relative-uri db label (string-append (page-protocol db label)
                                        "://"
                                        (page-server db label)
                                        "/sty/stengel.css")))

(define (favicon-uri db label)
  (relative-uri db label (string-append (page-protocol db label)
                                        "://"
                                        (page-server db label)
                                        "/favicon.ico")))

(define top-label "top")
(define (top-href db label)
  (relative-uri db label top-label))
(define (up-href db label)
  (and-let* ((up-elt (eltofpage-ref db label 'up)))
            (apply purl db label (rest up-elt))))
(define (next-href db label)
  (and-let* ((next-elt (eltofpage-ref db label 'next)))
            (apply purl db label (rest next-elt))))
(define (contents-href db label)
  (purl db label top-label "conts"))
(define (endorse-href db label)
  (purl db label "colsa" "indoors"))
(define contact-label "contact")
(define (contact-href db label)
  (purl db label contact-label))

;; not quite at the right place
(define donate-labels (circular-list "baalpfig"
                                     "5kronen-priesterin"
                                     "tuerschnorrer"))
(define n-donate-labels 3)
(define (random-index) (modulo (time) n-donate-labels))
(define (subsequent-label label)
  (let loop ((i 0) (ls donate-labels))
    (cond ((= i n-donate-labels) #f)
          ((string= label (first ls)) (second ls))
          (else (loop (+ i 1) (rest ls))))))
(define (donate-label db label)
  (cond ((subsequent-label label) => (lambda (l) l))
        (else (list-ref donate-labels (random-index)))))
(define (donate-href db label)
  (relative-uri db label (donate-label db label)))


;;; sxml trafos for schnada.de

(define (trafo-page . elt)
  `((final ,dt-html4s) ,nl
    (html (noodle ,(elt-ref elt 'title) ,(elt-ref elt 'about))
          (body ,(elt-attrilist elt)
                (header) ,@(elt-elements-after elt 'title) (footer)))))

(define (trafo-dsc . elt)
  `(meta (@ (name "description") ,@(elt-attributes elt)
            (content ,@(elt-elements elt)))))

(define (trafo-kwords . elt)
  `(meta (@ (name "keywords") ,@(elt-attributes elt)
            (content ,@(elt-elements elt)))))

(define (trafo-header db label)
  (if (string= label "impressum") '()
      `(div (@ (class "header"))
            (a (@ (href ,(page-uri db label))
                  (title "this page on " ,(page-server-description db label)))
               (span 9658))

            ;; 23478 = chinese symbol for home
            ;; big black dot = initial state in state diagram:
            ;; * bull = 8226 - smallish
            ;; * 9679 = black circle; middling
            ;; * 11044 = black large circle
            ;; * 10625 = z notation spot; smallish
            ;; 128274 = LOCK U+1F512
            ;; 128279 = LINK SYMBOL U+1F517
            (apage (@ (title "Home")) "top" "" 9679)" "thinsp
            (apage (@ (name "impressum") (lang "de") (title "legal notice / disclosure")) "impressum" ""
                   "Impressum"))))

(define (trafo-footer db label)
  `(div (@ (class "footer"))
        (address (@ (lang "en"))
                 "maintained by "
                 (a (@ (href ,(contact-href db label))) "Mr"8201"Schnada")
                 (crypt " <webmaster at schnada de>")
                 nbsp "zorglub" nbsp
                 ;; Z means UTC
                 (final ,(format-date "~Y-~m-~d&nbsp;~H:~MZ" (date (time) 0))))
        (navibar)
        (checker)))


(define (trafo-navibar db label)
  `(p (@ (class "navbar") (lang "en"))
      "[ "
      ,@(if (next-href db label)
           `(((a (@ (href ,(next-href db label))) "Next") " | "))
           '())
      ,(if (up-href db label)
           `(a (@ (href ,(up-href db label))) "Up")
           "Up")
      " | "
      ,(if (equal? label top-label) "Top"
	   `(a (@ (href ,(top-href db label))) "Top"))
      " | "
      (a (@ (href ,(contents-href db label))) "Contents")
      " | "
      (a (@ (href ,(endorse-href db label))) "Endorse")
      " | "
      (a (@ (href ,(donate-href db label))) "Donate")
      " | "
      ,(if (equal? label contact-label) "Contact"
	   `(a (@ (href ,(contact-href db label))) "Contact"))
      " | "
      ,(if (string= label "impressum") "Disclosure"
           '(apage "impressum" "" "Disclosure"))
      " ]"))


(define (trafo-noodle title about db label)
  `(head ()
     (meta (@ (http-equiv "Content-Type")
              (content "text/html; charset=iso-8859-1")))
     (meta (@ (http-equiv "Content-Style-Type")
              (content "text/css")))
     (meta (@ (name "viewport")
              (content "width=device-width, initial-scale=1")))
     ,title
     (link (@ (rel "StyleSheet")
              (href ,(relative-uri db label (stengel-uri db label)))
              (type "text/css")))
     (link (@ (rel "shortcut icon")
              (href ,(relative-uri db label (favicon-uri db label)))))
     ,@(if about (elt-elements about) '())))


(define (heading-weight->tag i)
  (string->symbol (format #f "h~a" (if i i 1))))

(define (trafo-heading _ attributes . elts)
  (let* ((id (or (and-let* ((id-binding (elt-ref attributes 'id)))
                           (second id-binding))
                 (and-let* ((name-binding (elt-ref attributes 'name)))
                           (second name-binding)) ; ...
                 (first elts)))
         (w8 (and-let* ((w8-binding (elt-ref attributes 'w8)))
                       (second w8-binding)))
         (@s (remove (lambda (name+value)
                       (member (first name+value) '(id w8 name)))
                     (rest attributes)))
         (tag (heading-weight->tag w8)))
    `(,tag (a (@ (name ,id) ,@@s) ,@elts))))

(define (make-illu-elt attributes w h)
  (let* ((size-atts (if (and w h)
                        `((width ,(number->string w))
                          (height ,(number->string h)))
                        '()))
         (img-atts (append size-atts (remove (lambda (a)
                                               (string= "innaface"
                                                        (second a)))
                                             (rest attributes))))
         (ximg-elt `(a (@ (href ,(second (elt-ref img-atts 'src))))
                       (img (@ ,@img-atts)))))
    (if (member '(class "innaface") attributes)
        `(p (@ (class "innaface")) ,ximg-elt)
        ximg-elt)))

(define (trafo-illu _ attributes db label)
  (let ((url (relative-uri db label
                           (second (elt-ref attributes 'src)))))
    (or (and-let* ((w-elt (elt-ref attributes 'width))
                   (h-elt (elt-ref attributes 'height)))
                  (make-illu-elt attributes #f #f))
        (receive (w h) (pic-dimension (uri->file-name url db label))
          (make-illu-elt attributes w h)))))


(define (trafo-sep _)
  '(p (@ (class "separ")) "*"))

(define (trafo-minisep _)
  '(p (@ (class "separ")) "."))

(define (trafo-quol _ attributes cit . lis)
  `(blockquote ,attributes
               ,@(separate-elements '(minisep)
                                    (map rest lis))
               ,cit))

(define (trafo-quotesl db label _ lis)
  (separate-elements '(sep)
                     (map (lambda (li) (quotes/name db (second li)))
                          lis)))

;; preferred form: (ali (hr "url") ...)
;; not quite xmly: (ali "url" ...)
(define (trafo-ali . elt)
  (let* ((subelts (elt-elements elt))
         (urle (first subelts))
         (url (if (string? urle) urle (first urle))))
    `(li (a (@ (href ,urle) ,@(elt-attributes elt))
            ,@(rest subelts)))))
(define (trafo-rf _ url) url)

(define (trafo-reli _ . xs)
  `(li 8594 ,@xs))

;; hrmph ...
;; args :: [ATTRIBUTE-SET] PAGE-LABEL [FRAGMENT-IDENTIFIER [ELT ...]]
(define (parse-args-4-apage args)
  (if (every attrilist? args)
      (error "empty <apage>"))
  (let* ((%args (if (attrilist? (first args)) args
                    (cons '(@) args)))
         (page (second %args))
         (attrilist (first %args)))
    (receive (fragment elts)
        (if (= 2 (length %args))
            (values "" '())
            (values (third %args) (cdddr %args)))
      (list attrilist page fragment elts))))

(define (trafo-apage db label attrilist plabel fragment elts)
  (let ((content (if (pair? elts) elts
                     (list (page-title/2 db plabel))))
        (attributions (rest attrilist)))
    `(a (@ (href ,(purl db label plabel fragment))
           ,@attributions)
        ,@content)))

(define (trafo-ares db label res-label elts)
  (let ((res (res db res-label)))
    (if (res-url res)
        `(a (@ (href ,(res-url res)))
            ,(res-text res))
        (res-text res))))

(define (trafo-chili db label date page elts)
  `(li ,(trafo-apage db label '(@) page "" elts)
       #\
       ,date))


;; today minus n months, approx
;; attr ::= (months <String>)
(define (date-before-months attr)
  (date (- (time) (* (string->number (second attr))
                     30 24 3600))))

(define (chilidate< s0 s1)
  (let ((y0 (string-copy s0 1 5)) (m0 (string-copy s0 5 7))
        (y1 (string-copy s1 1 5)) (m1 (string-copy s1 5 7)))
    (or (string< y0 y1)
        (and (string= y0 y1)
             (< (string->number m0)
                (string->number m1))))))

;; assumes format ul ::= (_ (_ "...200705" ...) etc)
(define (take-chilis ul delta)
  (if (not delta) ul
      (let ((pre-date (format-date "x~Y~m" (date-before-months delta)))
            (chili-datefield second))
        `(ul ,@(take-while (lambda (chili)
                             (chilidate< pre-date (chili-datefield chili)))
                           (rest ul))
             (li "continued in the " (apage "changelog"))))))

(define (trafo-chil _ . maybe-@)
  (with-input-from-file "../pages/fragments/changes.scm"
    (lambda ()
      (take-chilis (read-cs)
                   (elt-ref (:optional maybe-@ '(@)) 'months)))))

#! skip paid referrals / web beacons
(define (trafo-amazona _ attributes . elts)
  `((a ,attributes ,@elts)
    (img (@ (src "http://www.assoc-amazon.de/e/ir?t=schnadade-21&l=ur2&o=3")
            (width "1") (height "1")      ; (border "0")
            (alt "")
            (style "border:none !important; margin:0px important!")))))
!#

;; just a regular link
(define (trafo-amazona _ attributes . elts)
  `(a ,attributes ,@elts))

(define dt-xhtml1 "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">")
(define nl (format #f "~%"))
(define dt-html4s
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">")
(define dt-html4l
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">")
(define dt-html4f
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\" \"http://www.w3.org/TR/html4/frameset.dtd\">")


(define (trafo-sxml/macros elt db label)
  (pre-post-order
         elt
         `((page *macro* . ,trafo-page)

           (checker *macro* . ,(lambda (_) (trafo-checker db label)))
           (navibar *macro* . ,(lambda (_) (trafo-navibar db label)))
           (noodle *macro* . ,(lambda (_ title about)
                                (trafo-noodle title about db label)))
           (dsc *macro* . ,trafo-dsc)
           (kwords *macro* . ,trafo-kwords)
           (header *macro* . ,(lambda (_) (trafo-header db label)))
           (footer *macro* . ,(lambda (_) (trafo-footer db label)))

           (heading *macro* . ,trafo-heading)
           (illu *macro* . ,(lambda (_ attributes)
                              (trafo-illu _ attributes db label)))

           (quotesl *macro* . ,(lambda (_ . lis)
                                 (trafo-quotesl db label _ lis)))
           (quol *macro* . ,trafo-quol)
           (minisep *macro* . ,trafo-minisep)
           (sep *macro* . ,trafo-sep)

           (reli *macro* . ,trafo-reli)
           (ali *macro* . ,trafo-ali)
           (rf *macro* . ,trafo-rf)
           (chili *macro* . ,(lambda (_ date page . elts)
                               (trafo-chili db label date page elts)))
           (chil *macro* . ,trafo-chil)

           (amazona *macro* . ,trafo-amazona)
           (ares *macro* . ,(lambda (_ res-label . xs)
                              (trafo-ares db label res-label xs)))
           (apage *macro* . ,(lambda (_ . args)
                               (apply trafo-apage db label
                                      (parse-args-4-apage args))))
           (purl *macro* . ,(lambda (_ plabel . fragments)
                              (apply purl db label plabel fragments)))

           (crypt *macro* . ,(lambda (_ . strings)
                               `(final ,@(map vercripple-string strings))))

           (*default* . ,(lambda xs xs))
           )))


;; expanded code
(define (page-xcode/2 db label)
  (trafo-sxml/macros (page-code (page-record db label)) db label))
